from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Bq_V0_1_0 = CommandToolBuilder(tool="bq", base_command=["bq"], inputs=[ToolInput(tag="in_api", input_type=Boolean(optional=True), prefix="--api", doc=InputDocumentation(doc=": API endpoint to talk to.\n(default: 'https://www.googleapis.com')")), ToolInput(tag="in_api_version", input_type=Boolean(optional=True), prefix="--api_version", doc=InputDocumentation(doc=": API version to use.\n(default: 'v2')")), ToolInput(tag="in_api_log", input_type=Boolean(optional=True), prefix="--apilog", doc=InputDocumentation(doc=": Turn on logging of all server requests and responses. If no string\nis provided, log to stdout; if a string is provided, instead log to that\nfile.")), ToolInput(tag="in_application_default_credential_file", input_type=Boolean(optional=True), prefix="--application_default_credential_file", doc=InputDocumentation(doc=": See https://developers.google.com/ident\nity/protocols/application-default-credentials for more info.\n(default: '')")), ToolInput(tag="in_big_query_rc", input_type=Boolean(optional=True), prefix="--bigqueryrc", doc=InputDocumentation(doc=": Path to configuration file. The configuration file specifies new\ndefaults for any flags, and can be overrridden by specifying the flag on the\ncommand line. If the --bigqueryrc flag is not specified, the BIGQUERYRC\nenvironment variable is used. If that is not specified, the path\n'~/.bigqueryrc' is used.\n(default: '/root/.bigqueryrc')")), ToolInput(tag="in_ca_certificates_file", input_type=Boolean(optional=True), prefix="--ca_certificates_file", doc=InputDocumentation(doc=": Location of CA certificates file.\n(default: '')")), ToolInput(tag="in_credential_file", input_type=Boolean(optional=True), prefix="--credential_file", doc=InputDocumentation(doc=": Filename used for storing the BigQuery OAuth token.\n(default: '/root/.bigquery.v2.token')")), ToolInput(tag="in_dataset_id", input_type=Boolean(optional=True), prefix="--dataset_id", doc=InputDocumentation(doc=": Default dataset to use for requests. (Ignored when not\napplicable.)\n(default: '')")), ToolInput(tag="in_discovery_file", input_type=Boolean(optional=True), prefix="--discovery_file", doc=InputDocumentation(doc=": Filename for JSON document to read for discovery.\n(default: '')")), ToolInput(tag="in_format", input_type=Boolean(optional=True), prefix="--format", doc=InputDocumentation(doc=": <none|json|prettyjson|csv|sparse|pretty>: Format for command output.\nOptions include:\npretty: formatted table output\nsparse: simpler table output\nprettyjson: easy-to-read JSON format\njson: maximally compact JSON\ncsv: csv format with header\nThe first three are intended to be human-readable, and the latter three are\nfor passing to another program. If no format is selected, one will be chosen\nbased on the command run.")), ToolInput(tag="in_job_id", input_type=Boolean(optional=True), prefix="--job_id", doc=InputDocumentation(doc=": A unique job_id to use for the request. If not specified, this\nclient will generate a job_id. Applies only to commands that launch jobs,\nsuch as cp, extract, load, and query.")), ToolInput(tag="in_job_property", input_type=Boolean(optional=True), prefix="--job_property", doc=InputDocumentation(doc=": Additional key-value pairs to include in the properties field\nof the job configuration;\nrepeat this option to specify a list of values")), ToolInput(tag="in_max_rows_per_request", input_type=Boolean(optional=True), prefix="--max_rows_per_request", doc=InputDocumentation(doc=": Specifies the max number of rows to return per read.\n(an integer)")), ToolInput(tag="in_project_id", input_type=Boolean(optional=True), prefix="--project_id", doc=InputDocumentation(doc=": Default project to use for requests.\n(default: '')")), ToolInput(tag="in_proxy_address", input_type=Boolean(optional=True), prefix="--proxy_address", doc=InputDocumentation(doc=": The name or IP address of the proxy host to use for\nconnecting to GCP.\n(default: '')")), ToolInput(tag="in_proxy_password", input_type=Boolean(optional=True), prefix="--proxy_password", doc=InputDocumentation(doc=": The password to use when authenticating with proxy host.\n(default: '')")), ToolInput(tag="in_proxy_port", input_type=Boolean(optional=True), prefix="--proxy_port", doc=InputDocumentation(doc=": The port number to use to connect to the proxy host.\n(default: '')")), ToolInput(tag="in_proxy_username", input_type=Boolean(optional=True), prefix="--proxy_username", doc=InputDocumentation(doc=": The user name to use when authenticating with proxy host.\n(default: '')")), ToolInput(tag="in__quiet_true", input_type=Boolean(optional=True), prefix="-q", doc=InputDocumentation(doc=",--[no]quiet: If True, ignore status updates while jobs are running.\n(default: 'false')")), ToolInput(tag="in_service_account", input_type=Boolean(optional=True), prefix="--service_account", doc=InputDocumentation(doc=": Use this service account email address for authorization.\nFor example, 1234567890@developer.gserviceaccount.com.\n(default: '')")), ToolInput(tag="in_service_account_credential_file", input_type=Boolean(optional=True), prefix="--service_account_credential_file", doc=InputDocumentation(doc=": File to be used as a credential store for\nservice accounts. Must be set if using a service account.")), ToolInput(tag="in_service_account_private_key_file", input_type=Boolean(optional=True), prefix="--service_account_private_key_file", doc=InputDocumentation(doc=": Filename that contains the service account\nprivate key. Required if --service_account is specified.\n(default: '')")), ToolInput(tag="in_service_account_private_key_password", input_type=Boolean(optional=True), prefix="--service_account_private_key_password", doc=InputDocumentation(doc=": Password for private key. This\npassword must match the password you set on the key when you created it in\nthe Google APIs Console. Defaults to the default Google APIs Console private\nkey password.\n(default: 'notasecret')")), ToolInput(tag="in_sync", input_type=Boolean(optional=True), prefix="-sync", doc=InputDocumentation(doc=",--[no]synchronous_mode: If True, wait for command completion before\nreturning, and use the job completion status for error codes. If False,\nsimply create the job, and use the success of job creation as the error\ncode.\n(default: 'true')")), ToolInput(tag="in_trace", input_type=Boolean(optional=True), prefix="--trace", doc=InputDocumentation(doc=": A tracing token of the form 'token:<token>' to include in api")), ToolInput(tag="in_auth_host_name", input_type=Boolean(optional=True), prefix="--auth_host_name", doc=InputDocumentation(doc=": Host name to use when running a local web server to handle\nredirects during OAuth authorization.\n(default: 'localhost')")), ToolInput(tag="in_auth_host_port", input_type=Boolean(optional=True), prefix="--auth_host_port", doc=InputDocumentation(doc=": Port to use when running a local web server to handle\nredirects during OAuth authorization.;\nrepeat this option to specify a list of values\n(default: '[8080, 8090]')\n(an integer)")), ToolInput(tag="in_flag_file", input_type=Boolean(optional=True), prefix="--flagfile", doc=InputDocumentation(doc=": Insert flag definitions from the given file into the command line.\n(default: '')")), ToolInput(tag="in_undef_ok", input_type=Boolean(optional=True), prefix="--undefok", doc=InputDocumentation(doc=": comma-separated list of flag names that it is okay to specify on\nthe command line even if the program does not define a flag with that name.\nIMPORTANT: flags in this list that have arguments MUST use the --flag=value\nformat.\n(default: '')")), ToolInput(tag="in_command_flags", input_type=Boolean(optional=True), prefix="--command_flags", doc=InputDocumentation(doc="")), ToolInput(tag="in_global_flags", input_type=Boolean(optional=True), prefix="--global_flags", doc=InputDocumentation(doc="")), ToolInput(tag="in_printing_dot", input_type=String(), position=0, doc=InputDocumentation(doc="(default: 'false')")), ToolInput(tag="in_requests_dot", input_type=String(), position=1, doc=InputDocumentation(doc="--[no]use_gce_service_account: Use this when running on a Google Compute"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Bq_V0_1_0().translate("wdl", allow_empty_container=True)

